theory NominalTest
imports Nominal Main

begin

text {*
   Small test case for some NHOML primitives.
  *}

  consts independenceDayTime :: "\<tau>"
         federalHallTime :: "\<tau>"
         independenceDay :: "\<eta>"
         federalHall :: "\<eta>"
         Pr :: "i \<Rightarrow> \<sigma>"
         W :: "i \<Rightarrow> \<sigma>"
  
  axiomatization where
      history: "independenceDayTime t< federalHallTime" and 
      description1: "independenceDay @@ independenceDayTime" and -- "assign nomimals"
      description2: "federalHall @@ federalHallTime"
  
  lemma True nitpick [satisfy, user_axioms=true, expect = genuine] oops

  lemma Later:
    shows "[L (<independenceDay> t\<rightarrow> F <federalHall>)]"
  by (metis description1 description2 history rightUnique)

  consts w :: "i" -- "washington"
  axiomatization where
    washington: "[W w]" and -- "w ist washington"
    w1: "\<not>((Pr w) independenceDayTime)" and -- "er war am independenceday nicht president"
    w2: "(Pr w) federalHallTime" -- "aber an einem späteren Zeitpunkt"

  lemma True nitpick [satisfy, user_axioms=true, expect = genuine] oops

  lemma WwasPresident:
    shows "[\<exists>(\<lambda>x. L (<federalHall> t\<rightarrow> (Pr x)))]"
  by (metis description2 rightUnique w2)

  lemma WwasnotPresidentBefore:
    shows "[\<exists>(\<lambda>x. L (<federalHall> t\<rightarrow> P (t\<not> (Pr x))))]"
  by (metis description2 history rightUnique w1)

  lemma WwastobePresident:
    shows "[\<exists>(\<lambda>x. L(<independenceDay> t\<rightarrow> F (Pr x)))]"
  by (metis description1 history rightUnique w2)

  lemma WwillAlwaysHaveBeenPresident:
    shows "[L (<federalHall> t\<rightarrow> Pr w)]"
  by (metis description2 rightUnique w2)

  abbreviation nominalDesc :: "\<sigma> \<Rightarrow> \<eta> \<Rightarrow> \<sigma>" (infixl "!!" 40)
    where "\<phi> !! i  \<equiv> L (<i> t\<rightarrow> \<phi>)"
  
  lemma WwillAlwaysHaveBeenPresident2:
    shows "[(Pr w) !! federalHall]"
  by (metis description2 rightUnique w2)


end
